/**
 * AbstractStructure.java
 *
 * File generated from the LDAStructure::AbstractStructure uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ldap.model;

// End of user code
import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * Description of the class AbstractStructure.
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AbstractStructure", propOrder = { "description", "name", "oid" })
@XmlRootElement(name = "AbstractStructure")
@MappedSuperclass
public abstract class AbstractStructure {

	@XmlElement(name = "description")
	@Column(name = "description")
	public String description;

	@XmlAttribute(name = "name", required = true)
	@Column(name = "name")
	public String name;

	@XmlAttribute(name = "oid", required = true)
	@Column(name = "oid")
	public String oid;

	public AbstractStructure() {

	}

	/**
	 * Return description.
	 * 
	 * @return description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * Set a value to attribute description.
	 * 
	 * @param description
	 *            .
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * Return name.
	 * 
	 * @return name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Set a value to attribute name.
	 * 
	 * @param name
	 *            .
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Return oid.
	 * 
	 * @return oid
	 */
	public java.lang.String getOid() {
		return oid;
	}

	/**
	 * Set a value to attribute oid.
	 * 
	 * @param oid
	 *            .
	 */
	public void setOid(java.lang.String oid) {
		this.oid = oid;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result) + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		AbstractStructure other = (AbstractStructure) obj;
		if (name == null) {
			if (other.name != null) {
				return false;
			}
		} else if (!name.equals(other.name)) {
			return false;
		}
		return true;
	}

}